/*
   This program demonstrates parameterized sorting of lists in Language_10.
*/

public class Language_10_Examples_2
{
   public static void main(String[] args)
   {
      String[] programs =
      {
         "( prog " +
            "( fun sort " +
               "( lambda lst cmp " +
                  "( begin " +
                     "( fun insert " +
                        "( lambda x lst " +
                           "( if ( empty? lst ) " +
                                "( cons x lst ) " +
                                "( if ( apply cmp x ( car lst ) ) " +
                                     "( cons x lst ) " +
                                     "( cons ( car lst ) ( apply insert x ( cdr lst ) ) ) ) ) ) ) " +
                     "( fun nestedSort " +
                        "( lambda lst " +
                           "( if ( empty? lst ) " +
                                "lst " +
                                "( apply insert ( car lst ) ( apply nestedSort ( cdr lst ) ) ) ) ) ) " +
                     "( apply nestedSort lst ) ) ) ) " +
            "( apply sort ( list 9 1 8 2 7 3 6 4 5 ) ( lambda x y ( < x y ) ) ) )",


         "( prog " +
            "( fun sort " +
               "( lambda lst cmp " +
                  "( begin " +
                     "( fun insert " +
                        "( lambda x lst " +
                           "( if ( empty? lst ) " +
                                "( cons x lst ) " +
                                "( if ( apply cmp x ( car lst ) ) " +
                                     "( cons x lst ) " +
                                     "( cons ( car lst ) ( apply insert x ( cdr lst ) ) ) ) ) ) ) " +
                     "( fun nestedSort " +
                        "( lambda lst " +
                           "( if ( empty? lst ) " +
                                "lst " +
                                "( apply insert ( car lst ) ( apply nestedSort ( cdr lst ) ) ) ) ) ) " +
                     "( apply nestedSort lst ) ) ) ) " +
            "( fun makeCmp " +
               "( lambda fn selector " +
                  "( lambda t1 t2 " +
                     "( apply fn ( apply selector t1 ) ( apply selector t2 ) ) ) ) ) " +
            "( fun selector ( lambda triple ( car ( cdr triple ) ) ) ) " +
            "( var triples ( list ( list 1 2 3 ) ( list 8 7 6 ) ( list 4 5 6 ) ( list 5 6 7 ) ) ) " +
            "( apply sort triples ( apply makeCmp ( lambda x y ( < x y ) ) selector ) ) )"
      };


      int i = 0;
      for (i = 0; i < programs.length; i++)
      {
         System.out.println(i + " =============================================");

         // Print the expression.
         //System.out.println( programs[i] + "\n" );

         // Build the abstract syntax tree that represents the expression.
         try
         {
            Tree ast = BuildTree.buildTree( programs[i] );

            // Print the AST as an S-expression
            //System.out.println( ast + "\n" );

            // Pretty-print the abstract syntax tree.
            System.out.println( PrettyPrinter.prettyPrint( ast ) + "\n" );

            // Print the infix version of the expression.
            System.out.println( AST2Infix.ast2infix( ast ) + "\n" );

            // Evaluate the expression (interpret the AST).
            try
            {
               Value value = Evaluate.eval( ast );
               System.out.println( "result = " + value + "\n" );
            }
            catch (EvalException e)
            {
               System.out.println(e);
             //e.printStackTrace();
            }


            // Create dot and png files from the AST.
            if(true)
            try
            {
               // Create the (empty) dot file.
               String baseName = String.format("Language_10_2.%02d", i);
               java.io.PrintWriter out = new java.io.PrintWriter(
                                            new java.io.File(baseName + ".dot") );
               // Put dot commands into the dot file
               out.println( Tree2dot_ver1.tree2dot(ast) + "\n" );
               out.close();
               // Create a command line for running dot.exe.
               String[] cmd = {"dot.exe",
                               "-Tpng",
                               baseName + ".dot",
                               "-o",
                               baseName + ".png"};
               // Execute the command line.
               java.lang.Runtime.getRuntime().exec(cmd);
            }
            catch (Exception e)
            {
               System.out.println( e );
            }
         }
         catch (ParseException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
      }
   }//main()

}//Language_10_Examples